// fight.cpp
// Fight functions
#include <allegro.h>
#include "fight.h"
#include <stdlib.h>
#include <cmath>

static BITMAP* person; //define the variables
static BITMAP* mmonster;

static int pos = 1;
static int x = 438;
static int y = 400;
static int playx = 600, playy = 300;
static int enemyx = 400, enemyy = 0;
int level = 1;

int hp;
int maxhp;

bool dead = false, quitfight = false;

static int attack, acc, str, def;
static bool enter = false, press = false;
int monpick;
char* monName;

int monLevel, monHp, monMaxhp, monAttack, monacc, monstr, mondef;


static void monster()
{
   if( present == true)
   {
      mmonster = load_bitmap("mon5.bmp", NULL);
      monName = "Little Demon";
   }
   if(ffuture == true)
   {
      srand(time(NULL));
      
      monpick = rand() % 4 + 1;
      
      if(monpick == 1)
      {
         mmonster = load_bitmap("mon1.bmp",NULL);
         monName = "Skelly";
		}
      if(monpick == 2)
      {
         mmonster = load_bitmap("mon2.bmp",NULL);
         monName = "Chronozon";
      }
		if(monpick == 3)
		{
         mmonster = load_bitmap("mon3.bmp",NULL);
         monName = "Aslon";
      }
		if(monpick == 4)
      { 
		   mmonster = load_bitmap("mon4.bmp",NULL);
         monName = "Hydra";
		}
	}
}

static void fight_load()
{
   text_mode(-1);
   srand(time(NULL));
   person = load_bitmap("guybattle.bmp", NULL); //loading the images
   
   monster();
   
	monLevel = rand() % 7 + (level - 3);
	
   if(monLevel <= 0)
      monLevel = 1;
   
	monMaxhp = (pow(monLevel, 1.05) * 60) + 100; 
   monHp = monMaxhp;
	
   maxhp = (pow(level, 1.05) * 60) + 100  ;  
   hp = maxhp;	
	
	str = rand() % 20 + (20 * level);
  	monstr = rand() % 15 + (15 * level);
	
	def = rand() % 20 + (20 * level);
	mondef = rand() % 15 + (15 * level);
}


static void fight_draw()
{
   
   rectfill(buffer, 0, 0, 800, 310, makecol(0,255,255));//background
   rectfill(buffer,0,310,800,600,makecol(0,255,0));


   masked_blit(person, buffer, 65, 0, 700, 300, 60, 75);//  player area
   

   masked_blit(mmonster, buffer, 65, 0, 0, 340, 60, 75);  //enemy area
                                          											                                          
   rectfill(buffer,0,500,330,600,makecol(192,192,192));
   rectfill(buffer,400,500,490,600,makecol(130,130,130));  //menu
	rect(buffer,0,500,330,601,makecol(0,0,0));
	rect(buffer,400,500,490,601,makecol(0,0,0));
	
	textprintf(buffer, font, 430, 515, 0, "Fight");
	textprintf(buffer, font, 430, 540, 0, "Item");  //menu options
	textprintf(buffer, font, 430, 565, 0, "Run");
	textprintf(buffer, font,   x,   y, 0, "->");
	
	
   textprintf(buffer, font, 30, 510, makecol(0,0,0), "Name: %s    Level: %d", monName, monLevel);
	textprintf(buffer, font, 70, 570, makecol(0,0,0), "Health: %d / %d", monHp, monMaxhp);
	rectfill(buffer, 39, 529, 280, 551, -1);
	rectfill(buffer, 40, 530, 40 + ((239 * monHp) / monMaxhp), 550, makecol(255,0,0));
	
	rectfill(buffer,501,500,800,600,makecol(192,192,192));
   textprintf(buffer, font, 510, 510, makecol(0,0,0), "Name: Christopher    Level: %d", level);
	textprintf(buffer, font, 550, 570, makecol(0,0,0), "Health: %d / %d", hp, maxhp);
	rectfill(buffer, 510, 529, 750, 551, -1);
	rectfill(buffer, 511, 530, 510 + ((239 * hp) / maxhp), 550, makecol(255,0,0));
	
	if( hp == 0)
	{
	  rectfill(buffer, 339, 299, 580, 321, -1);
	} 
	
	blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_W);
}

static void fight_logic()
{
  	
  	srand(time(NULL));
  	
	attack = rand() % 20 + ((acc + str) - mondef);
	monAttack = rand() % 10 + ((monacc + monstr) - def);
	
	acc = rand() % 20 + 1;
   monacc = rand() % 20 + 1;

   if(key[KEY_DOWN] && pos == 1)
   {
      if(press != true)
     	   pos = 2;
	   press = true;
   }
	else if(key[KEY_DOWN] && pos == 2)
   {
      if(press != true)
     	   pos = 3;
	   press = true;
   }

   else if(key[KEY_UP] && pos == 3)
   {
	   if(press != true)
     	   pos = 2;
	   press = true;
   }
   else if(key[KEY_UP] && pos == 2)
   {
	   
	   if(press != true)
	      pos = 1;
	   press = true;
   }
   else
   {
	   press = false;
	}

   if(pos == 1)
   {
      x = 410;
      y = 515;
   }
   
	if(pos == 2)
   {
      x = 410;
      y = 540;
   }   
   
	if(pos == 3)
   {
      x = 410;
      y = 565;
   }
   
   
   if(pos == 1 && key[KEY_ENTER])
   {		
		if(enter != true)
   	{	
   	   
   	   playx += 15;
   	   playy -= 15;
   	   		
			fight_draw();
   	   
   	   playx -= 15;
   	   playy += 15;
			
			textprintf(screen, font, 330, 210, 0, "      * ");
			textprintf(screen, font, 330, 220, 0, "*           *" );
			textprintf(screen, font, 330, 230, 0, "   *     *");
			textprintf(screen, font, 330, 240, 0, "*           *");
			textprintf(screen, font, 330, 250, 0, "   *     *");
			textprintf(screen, font, 330, 260, 0, "*           *");
   	   textprintf(screen, font, 330, 270, 0, "      *");
   	   
	      if((acc + str) >= mondef)
	      {
	         monHp -= attack;
	         textprintf(screen, font, 365, 240, 0, "- %d", attack);
	      }
	      else
	      {
	         textprintf(screen, font, 365, 240, 0,"Miss!");
	      }
	      	      
			rest(1000);

			if( monHp <= 0)
         {
            monHp = 0;
            level += 1;
		      rest(300);
		      quitfight = true;
		      return;
			}
			
			fight_draw();
			rest(300);
			
			enemyx -= 15;
   	   enemyy += 15;
   	   
   	   fight_draw();
   	   
   	   enemyx += 15;
   	   enemyy -= 15;
			
			textprintf(screen, font, 330, 210, makecol(200,0,0), "      * ");
			textprintf(screen, font, 330, 220, makecol(200,0,0), "*           *" );
			textprintf(screen, font, 330, 230, makecol(200,0,0), "   *     *");
			textprintf(screen, font, 330, 240, makecol(200,0,0), "*           *");
			textprintf(screen, font, 330, 250, makecol(200,0,0), "   *     *");
			textprintf(screen, font, 330, 260, makecol(200,0,0), "*           *");
   	   textprintf(screen, font, 330, 270, makecol(200,0,0), "      *");
   	   
   	   
						
		   if(( monacc + monstr ) >= def )
		   {
		      hp -= monAttack;
		      textprintf(screen, font, 365, 240, makecol(200,0,0), "- %d", monAttack);
	      }
	      else
	      {
	         textprintf(screen, font, 365, 240, makecol(200,0,0),"Miss!");
	      }
	      
			if( hp <= 0)
         {
            hp = 0;
     		   fight_draw();
		      rest(300);
		      quitfight = true;
		      dead = true;
		      return;
			}		
				 
	      rest(1000);
		}
      enter = true;
      
   }
   
   else
	{
	   enter = false;
   }
   
   if(pos == 2 && key[KEY_ENTER])
   {
      while(!key[KEY_SPACE])
      {
         textprintf(screen, font, 150,252,0,"Due to our games budget items were not added into the game.");
         textprintf(screen, font, 150,261,0,"If you would like to send us money we might add a slightly shotgun'd computer.");
         textprintf(screen, font, 150,270,0,"Press space to continue.");
      }
   }
   if(pos == 3 && key[KEY_ENTER])
   {
   	quitfight = true;
  	}
}

void fightmain()
{
	fight_load();
	while(!quitfight)
	{
		if(last_time < current_time)
		{
			++last_time;
	     		fight_logic();
		}
		fight_draw();
	 	if(key[KEY_ESC])
			quitfight = true;
	}
	fighting = false;
                quitfight = false;
	if(dead)
	{
		//gonna put a you died screen here
		quit = true;
	}	
	return;
}




